package org.gcube.application.geoportal.service;

import javax.persistence.EntityManagerFactory;
import javax.ws.rs.core.Application;

import org.gcube.application.geoportal.managers.AbstractRecordManager;
import org.gcube.application.geoportal.model.fault.ConfigurationException;
import org.gcube.application.geoportal.service.engine.ImplementationProvider;
import org.gcube.application.geoportal.service.engine.ScopedEMFProvider;
import org.gcube.application.geoportal.service.engine.StorageClientProvider;
import org.gcube.application.geoportal.service.legacy.TokenSetter;
import org.gcube.contentmanagement.blobstorage.service.IClient;
import org.glassfish.jersey.test.JerseyTest;
import org.junit.BeforeClass;

public class BasicServiceTestUnit extends JerseyTest {

	
	
	@Override
	protected Application configure() {
		return new GeoPortalService();
	}
	

	
	@BeforeClass
	public static void init() {
		String scope="/gcube/devsec/devVRE";
		AbstractRecordManager.setDefaultProvider(
		
		new ScopedEMFProvider(){
			
			@Override
			public EntityManagerFactory getFactory() {
//				System.err.println("***********************SETTING DEBUG CONTEXT******************");
				TokenSetter.set(scope);
				return super.getFactory();
			}
		});
		
		ImplementationProvider.get().setStorageProvider(new StorageClientProvider() {
			@Override
			public IClient getObject() throws ConfigurationException {
				TokenSetter.set(scope);
				return super.getObject();
			}
		});
		
	}
}
